using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using NI.Email.Mime.Message;
using NI.Email.Mime.Field;
using NI.Email.Mime.Util;

using NI.Email.Smtp;

namespace NI.Mime4Net.Samples.ComposeAndSend {
	
	public class Program {
		
		static void Main(string[] args) {

			string toEmail = Ask("Enter destination email", false);
			string server = Ask("Enter SMTP server", false);
			string username = Ask("Enter SMTP server username (press enter to skip auth)", true);
			string pwd = Ask("Enter SMTP server password (press enter to skip auth)",true);

			MimeMessage msg = new MimeMessage();
			Header header = new Header();
			msg.Header = header;
			header.AddField(MimeField.ComposeContentType(ContentTypeField.TypeTextPlain));
			header.AddField(MimeField.ComposeFrom(toEmail));
			header.AddField(MimeField.ComposeTo(toEmail));
			header.AddField(MimeField.ComposeSubject(@"M4N: compose and send test"));
			msg.Body = new MemoryTextBody(
				new MemoryStream(Encoding.ASCII.GetBytes(@"Hello from Mime4Net!")));

			MemoryStream memStream = new MemoryStream();
			msg.WriteTo(memStream);
			memStream.Position = 0;

			bool isGmail = server=="smtp.gmail.com";
			SmtpClient smtp = new SmtpClient(server,isGmail ? 587 : 25,
				username.Trim().Length>0 ? username : null,
				pwd.Trim().Length > 0 ? pwd : null, 
				isGmail);

			Console.WriteLine("Sending...");

			smtp.Connect();
			smtp.Send(toEmail, toEmail, memStream);
			smtp.Close();

			Console.WriteLine("Now check your inbox.");
		}

		static string Ask(string s, bool allowEmpty) {
			Console.Write(s+": ");
			string l = String.Empty;
			do {
				l = Console.ReadLine().Trim();
			} while (String.IsNullOrEmpty(l) && !allowEmpty);
 			return l;
		}


	}
}
