using System;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;
using System.Web.UI.WebControls;
using System.Web.UI;

using NI.Email.Mime;
using NI.Email.Mime.Message;
using NI.Email.Mime.Field;

public partial class SimpleViewMessage : System.Web.UI.Page
{
    private MimeMessage _Message;

    protected MimeMessage Message
    {
        get { return _Message; }
    }

    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);
		string strMessage = "bluedot-postcard-embedded.msg";
        _Message = new MimeMessage(new FileStream(Regex.Replace(Page.MapPath(Page.AppRelativeVirtualPath), @"\\[^.]+[.]aspx$", @"\" + strMessage, RegexOptions.Compiled | RegexOptions.Singleline), FileMode.Open, FileAccess.Read));
        if (!IsPostBack)
        {
            DataBind();
        }
    }

    protected string ShowMessageBody()
    {
        string result = String.Empty;
        if (Message.IsMimeType("multipart/related"))
        {
            foreach (BodyPart bp in (Message.Body as Multipart).BodyParts)
            {
                if (bp.Body is ITextBody)
                {
                    if (bp.MimeType == ContentTypeField.TypeTextPlain)
                    {
                        result += "<pre>";
                        result += (bp.Body as ITextBody).Reader.ReadToEnd();
                        result += "</pre><br/><hr/><br/>";
                    }
                    else if (bp.MimeType == ContentTypeField.TypeTextHtml)
                    {
                        result += (bp.Body as ITextBody).Reader.ReadToEnd();
                        result += "<br/><hr/><br/>";
                    }
                }
            }
        }
        else if (Message.Body is Multipart)
        {
            foreach (BodyPart bp in (Message.Body as Multipart).BodyParts)
            {
                if (bp.Body is ITextBody)
                {
                    if (bp.MimeType == ContentTypeField.TypeTextPlain)
                    {
                        result += "<pre>";
                        result += (bp.Body as ITextBody).Reader.ReadToEnd();
                        result += "</pre><br/><hr/><br/>";
                    }
                    else
                    {
                        result += (bp.Body as ITextBody).Reader.ReadToEnd();
                        result += "<br/><hr/><br/>";
                    }
                }
            }
        }
        else if (Message.Body is ITextBody)
        {
            result += (Message.Body as ITextBody).Reader.ReadToEnd();
            result += "<br/><hr/><br/>";
        }
        return result;
    }

	protected ArrayList GetAttachmentLinks(Entity mimeEntity)
	{
		ArrayList result = GetAttachmentLinksInternal(mimeEntity, 0);
		return result.Count > 0 ? result : null;
	}

    protected ArrayList GetAttachmentLinksInternal(Entity mimeEntity, int indexOffset)
    {
        ArrayList result = new ArrayList();
        if (mimeEntity.IsMultipart)
        {
            IList bps = ((Multipart)mimeEntity.Body).BodyParts;
            for (int i = 0; i < bps.Count; ++i)
            {
                BodyPart currentBp = bps[i] as BodyPart;
                ContentTypeField contentType = currentBp.Header.GetField(MimeField.ContentType) as ContentTypeField;
                if (contentType == null) continue;

                if (currentBp.Body is MimeMessage)
                {
                    result.Add(i + indexOffset);
                    result.AddRange(GetAttachmentLinksInternal((MimeMessage)currentBp.Body, i + indexOffset));
                }
                else if (!(currentBp.Body is ITextBody) && !currentBp.Parent.IsMimeType("multipart/related"))
                {
                    result.Add(i + indexOffset);
                }
            }
        }
        return result;
    }
	
	protected bool HasMessageAttachments(Entity message)
	{
		ArrayList result = GetAttachmentLinksInternal(message, 0);
		return result != null && result.Count > 0;
	}
}
