using System;

using NI.Email.Mime;
using NUnit.Framework;

using NI.Email.Mime.Decoder;

namespace NI.Tests.Email.Mime
{
    [TestFixture]
    public class HeaderQBEncDecTest
    {
        [Test]
        public void test_EncDecQB()
        {
            string testStrQSpaced = "This is text with some non-ASCII chars, some russian and ukrainian (cyrillic) letters, i.e.  ; have fun and do not forget to form your mime message properly ))";
            string testStrQ = "This is text with some non-ASCII chars, some russian and ukrainian (cyrillic) letters, i.e.  and ; have fun and do not forget to form your mime message properly ))";
            string testStrQUnderscored = "This_is_text with some non-ASCII chars, some russian and ukrainian (cyrillic) letters, i.e.  and _; have fun and do not forget to form your mime message properly ))";

            string testStrBSpaced = "hehe,     ,    -)";
            string testStrB = "hehe,  mime  mime  mime , mime  mime  mime  mime -); no spaces!";
            string testStrBUnderscored = "hehe,   _  , _ _ -)";
            string testStrBTotalNonAscii = " ";

            string testStrQEncoded = DecoderUtil.EncodeWords(testStrQ);
            string testStrQUnderscoredEncoded = DecoderUtil.EncodeWords(testStrQUnderscored);
            string testStrQSpacedEncoded = DecoderUtil.EncodeWords(testStrQSpaced);

            string testStrBEncoded = DecoderUtil.EncodeWords(testStrB);
            string testStrBSpacedEncoded = DecoderUtil.EncodeWords(testStrBSpaced);
            string testStrBUnderscoredEncoded = DecoderUtil.EncodeWords(testStrBUnderscored);
            string testStrBTotalNonAsciiEncoded = DecoderUtil.EncodeWords(testStrBTotalNonAscii);
            
            string testStrQDecoded = DecoderUtil.DecodeEncodedWords(testStrQEncoded);
            string testStrQUnderscoredDecoded = DecoderUtil.DecodeEncodedWords(testStrQUnderscoredEncoded);
            string testStrQSpacedDecoded = DecoderUtil.DecodeEncodedWords(testStrQSpacedEncoded);

            string testStrBDecoded = DecoderUtil.DecodeEncodedWords(testStrBEncoded);
            string testStrBSpacedDecoded = DecoderUtil.DecodeEncodedWords(testStrBSpacedEncoded);
            string testStrBUnderscoredDecoded = DecoderUtil.DecodeEncodedWords(testStrBUnderscoredEncoded);
            string testStrBTotalNonAsciiDecoded = DecoderUtil.DecodeEncodedWords(testStrBTotalNonAsciiEncoded);
            
            Assert.AreEqual(testStrQ, testStrQDecoded);
            Assert.AreEqual(testStrQSpaced, testStrQSpacedDecoded);
            Assert.AreEqual(testStrQUnderscored, testStrQUnderscoredDecoded);

            Assert.AreEqual(testStrB, testStrBDecoded);
            Assert.AreEqual(testStrBSpaced, testStrBSpacedDecoded);
            Assert.AreEqual(testStrBUnderscored, testStrBUnderscoredDecoded);
            Assert.AreEqual(testStrBTotalNonAscii, testStrBTotalNonAsciiDecoded);
        }
    }
}
